//---------------------------------------------------------------------------
//
//                     XMM Science Analysis System (SAS)
//                    (c) 1997-2010 European Space Agency
//
//---------------------------------------------------------------------------
//
//	DssMisc.cc: --- implementation of miscellaneous DSS stuff
//
//	CHANGE HISTORY:
//		UL, 1999-11-16: 1.0.0: - first version
//
//	REFERENCES:
//		[1]: Documentation of selectlib package, U. Lammers
//
//	AUTHOR:
//		U. Lammers (UL), Tue Nov 16 09:56:55 MET 1999
//
//	$Header: /data/xmm12/cvsadmin/soc_repos/task_devel/packages/dsslib/src/dssbuild/DssMisc.cc,v 1.2 1999/11/18 18:06:36 ulammers Exp $
//

#include <cmath>

#include "Tracer.h"
#include "DssMisc.h"

namespace DssMisc {

//
//	PURPOSE:
//		Return fractional part of floating point number; disregard the
//		integer part
//
double modf(double d)
{
	PROC

	double idum;
	RETURN ::modf(d, &idum);
} // DssMisc::modf()


double intf(double d)
{
	PROC
	double idum;
	::modf(d, &idum);

	RETURN idum;
} // dssMisc::int()

};
