
/*  A Bison parser, made from DssParser.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	PLUS	258
#define	MINUS	259
#define	MULT	260
#define	DIV	261
#define	EXPO	262
#define	MODULO	263
#define	ANDIF	264
#define	ORIF	265
#define	NOT	266
#define	BLOCKFILTER1	267
#define	BLOCKFILTER2	268
#define	IN	269
#define	RELOP	270
#define	AND	271
#define	OR	272
#define	XOR	273
#define	LSHIFT	274
#define	RSHIFT	275
#define	BITCOMPL	276
#define	TRUECONST	277
#define	FALSECONST	278
#define	RPOINT	279
#define	RLINE	280
#define	RCIRCLE	281
#define	RRING	282
#define	RELLIPSE	283
#define	RELLIPSERING	284
#define	RBOX	285
#define	RRECTANGLE	286
#define	RPOLYGON	287
#define	RSECTOR	288
#define	RDIAMOND	289
#define	BLOCK	290
#define	NUMBER	291
#define	AXISNAME	292
#define	AFUNC1	293
#define	AFUNC2	294

#line 1 "DssParser.y"

  //---------------------------------------------------------------------------
  //
  //                     XMM Science Analysis System (SAS)
  //                   (c) 1997-2010 European Space Agency
  //
  //---------------------------------------------------------------------------
  //
  //  DssGrammar.y --- grammar for DSS expressions
  //
  //  DESCRIPTION:
  //      This is a yacc/bison input file which defines the grammar of
  //      DSS-compliant selection expressions.
  //
  //  CHANGE HISTORY:
  //      UL, 1999-11-16: 1.0.0: - first version
  //      UL, 1999-12-17: 1.1.0: - brought in line with selectlib-4.23
  //                               (Region->GeoRegion)
  //
  //  AUTHOR:
  //      U. Lammers (UL), Tue Nov 16 10:35:01 MET 1999
  //
  //  $Header: /data/xmm12/cvsadmin/soc_repos/task_devel/packages/dsslib/src/dssbuild/DssParser.y,v 1.3 1999/12/17 10:51:36 ulammers Exp $
  ///

#include <cmath>
#include <climits>
#include <string>
#include <stdio.h>

#include "basicdefs.h"
#include "Dal.h"
#include "DssBuilder.h"

#define YYDEBUG 1

#define yylex       dsslex
  extern int dsslex();        //  this is the name of the lexer function
                              //  that flex generates with the -Pdss
                              //  option; we do need a distinct name
                              //  in order to avoid name clashes with
                              //  other lexers in the SAS

  namespace DssParser {

    extern void yyerror(char *);    //  The locally added functions in the
                                    //  lexer are in a namespace DssParser

    enum RelOp {LtOpT=1, LeOpT, GtOpT, GeOpT, EqOpT, NeOpT};
    
    extern const Table * yyFilteredTable;

    
#line 55 "DssParser.y"
typedef union {
    double                  yNumber;
    string                  *yBlockSpec;
    string                  *yAxisName;
    double                  (*yFunc1)(double);
    double                  (*yFunc2)(double, double);
    DRange                  *yRange;
    DRangeList              *yRangeList;
    vector<float>           *yPointList;
    RelOp                   yRelOp;
  } YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		405
#define	YYFLAG		-32768
#define	YYNTBASE	46

#define YYTRANSLATE(x) ((unsigned)(x) <= 294 ? yytranslate[x] : 56)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    40,
    41,     2,     2,    42,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    43,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    44,     2,    45,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     6,    10,    14,    16,    18,    22,    26,    32,
    40,    47,    54,    65,    74,    89,   102,   106,   110,   112,
   117,   120,   128,   141,   156,   173,   196,   213,   230,   247,
   262,   271,   280,   291,   304,   323,   336,   349,   362,   373,
   378,   384,   388,   392,   394,   398,   402,   406,   410,   414,
   418,   422,   426,   430,   434,   438,   441,   446,   453,   456,
   460,   462,   464,   468,   472,   476,   480,   482,   486,   489,
   494,   499,   504,   509,   512,   517,   522,   527,   532,   536,
   542,   548,   554
};

static const short yyrhs[] = {    47,
     0,    40,    47,    41,     0,    47,     9,    47,     0,    47,
    10,    47,     0,    49,     0,    37,     0,    40,    37,    41,
     0,    48,    14,    53,     0,    48,    16,    36,    15,    36,
     0,    40,    48,    16,    36,    41,    15,    36,     0,    48,
    14,    12,    40,    35,    41,     0,    12,    40,    35,    42,
    48,    41,     0,    40,    48,    42,    48,    41,    14,    13,
    40,    35,    41,     0,    13,    40,    35,    42,    48,    42,
    48,    41,     0,    40,    48,    42,    48,    41,    14,    13,
    40,    35,    42,    54,    42,    54,    41,     0,    13,    40,
    35,    42,    54,    42,    54,    42,    48,    42,    48,    41,
     0,    48,    15,    54,     0,    54,    15,    48,     0,    50,
     0,    11,    40,    50,    41,     0,    11,    50,     0,    40,
    48,    42,    48,    41,    14,    51,     0,    26,    40,    54,
    42,    54,    42,    54,    42,    48,    42,    48,    41,     0,
    27,    40,    54,    42,    54,    42,    54,    42,    54,    42,
    48,    42,    48,    41,     0,    28,    40,    54,    42,    54,
    42,    54,    42,    54,    42,    54,    42,    48,    42,    48,
    41,     0,    29,    40,    54,    42,    54,    42,    54,    42,
    54,    42,    54,    42,    54,    42,    54,    42,    54,    42,
    48,    42,    48,    41,     0,    30,    40,    54,    42,    54,
    42,    54,    42,    54,    42,    54,    42,    48,    42,    48,
    41,     0,    31,    40,    54,    42,    54,    42,    54,    42,
    54,    42,    54,    42,    48,    42,    48,    41,     0,    34,
    40,    54,    42,    54,    42,    54,    42,    54,    42,    54,
    42,    48,    42,    48,    41,     0,    33,    40,    54,    42,
    54,    42,    54,    42,    54,    42,    48,    42,    48,    41,
     0,    32,    40,    52,    42,    48,    42,    48,    41,     0,
    26,    40,    54,    42,    54,    42,    54,    41,     0,    27,
    40,    54,    42,    54,    42,    54,    42,    54,    41,     0,
    28,    40,    54,    42,    54,    42,    54,    42,    54,    42,
    54,    41,     0,    29,    40,    54,    42,    54,    42,    54,
    42,    54,    42,    54,    42,    54,    42,    54,    42,    54,
    41,     0,    30,    40,    54,    42,    54,    42,    54,    42,
    54,    42,    54,    41,     0,    31,    40,    54,    42,    54,
    42,    54,    42,    54,    42,    54,    41,     0,    34,    40,
    54,    42,    54,    42,    54,    42,    54,    42,    54,    41,
     0,    33,    40,    54,    42,    54,    42,    54,    42,    54,
    41,     0,    32,    40,    52,    41,     0,    52,    42,    54,
    42,    54,     0,    54,    42,    54,     0,    53,    42,    55,
     0,    55,     0,    54,     3,    54,     0,    54,     4,    54,
     0,    54,     5,    54,     0,    54,     6,    54,     0,    54,
     8,    54,     0,    54,     7,    54,     0,    54,    16,    54,
     0,    54,    17,    54,     0,    54,    18,    54,     0,    54,
    19,    54,     0,    54,    20,    54,     0,    21,    54,     0,
    38,    40,    54,    41,     0,    39,    40,    54,    42,    54,
    41,     0,     4,    54,     0,    40,    54,    41,     0,    36,
     0,    43,     0,    44,    43,    45,     0,    40,    43,    45,
     0,    44,    43,    41,     0,    40,    43,    41,     0,    54,
     0,    44,    54,    45,     0,    54,    43,     0,    44,    54,
    43,    45,     0,    44,    54,    43,    41,     0,    40,    54,
    43,    45,     0,    40,    54,    43,    41,     0,    43,    54,
     0,    44,    43,    54,    45,     0,    44,    43,    54,    41,
     0,    40,    43,    54,    45,     0,    40,    43,    54,    41,
     0,    54,    43,    54,     0,    44,    54,    43,    54,    45,
     0,    40,    54,    43,    54,    45,     0,    44,    54,    43,
    54,    41,     0,    40,    54,    43,    54,    41,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   100,   103,   104,   105,   106,   108,   109,   111,   123,   139,
   155,   167,   179,   188,   197,   211,   225,   267,   308,   319,
   321,   322,   325,   330,   335,   340,   345,   350,   355,   360,
   365,   372,   375,   378,   381,   384,   387,   390,   393,   396,
   401,   406,   414,   419,   424,   425,   426,   427,   434,   441,
   449,   450,   451,   452,   453,   454,   455,   456,   458,   459,
   460,   462,   464,   466,   468,   470,   472,   473,   474,   476,
   478,   480,   482,   484,   486,   488,   490,   492,   494,   495,
   496,   498,   500
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","PLUS","MINUS",
"MULT","DIV","EXPO","MODULO","ANDIF","ORIF","NOT","BLOCKFILTER1","BLOCKFILTER2",
"IN","RELOP","AND","OR","XOR","LSHIFT","RSHIFT","BITCOMPL","TRUECONST","FALSECONST",
"RPOINT","RLINE","RCIRCLE","RRING","RELLIPSE","RELLIPSERING","RBOX","RRECTANGLE",
"RPOLYGON","RSECTOR","RDIAMOND","BLOCK","NUMBER","AXISNAME","AFUNC1","AFUNC2",
"'('","')'","','","':'","'['","']'","dssexpr","dss","axisname","filter","regionfilter",
"regiontype","pointlist","intervallist","arith","intervalspec", NULL
};
#endif

static const short yyr1[] = {     0,
    46,    47,    47,    47,    47,    48,    48,    49,    49,    49,
    49,    49,    49,    49,    49,    49,    49,    49,    49,    50,
    50,    50,    50,    50,    50,    50,    50,    50,    50,    50,
    50,    51,    51,    51,    51,    51,    51,    51,    51,    51,
    52,    52,    53,    53,    54,    54,    54,    54,    54,    54,
    54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
    54,    55,    55,    55,    55,    55,    55,    55,    55,    55,
    55,    55,    55,    55,    55,    55,    55,    55,    55,    55,
    55,    55,    55
};

static const short yyr2[] = {     0,
     1,     3,     3,     3,     1,     1,     3,     3,     5,     7,
     6,     6,    10,     8,    14,    12,     3,     3,     1,     4,
     2,     7,    12,    14,    16,    22,    16,    16,    16,    14,
     8,     8,    10,    12,    18,    12,    12,    12,    10,     4,
     5,     3,     3,     1,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     2,     4,     6,     2,     3,
     1,     1,     3,     3,     3,     3,     1,     3,     2,     4,
     4,     4,     4,     2,     4,     4,     4,     4,     3,     5,
     5,     5,     5
};

static const short yydefact[] = {     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    61,     6,     0,     0,     0,     1,
     0,     5,    19,     0,     0,    59,     0,    21,     0,     0,
    56,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     6,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     7,     2,     0,     0,    60,     3,     4,     0,     0,
    62,     0,     8,    67,    44,    17,     0,    45,    46,    47,
    48,    50,    49,     0,    18,    51,    52,    53,    54,    55,
     0,    20,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    57,     0,     0,     0,     0,     0,
     0,    74,     0,     0,     0,    69,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    42,     0,     0,     0,     0,     0,     0,    66,    64,
     0,     0,    65,    63,     0,     0,    68,    43,    79,     9,
     0,    12,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    58,     0,     0,    11,    78,    77,
    73,    72,     0,    76,    75,    71,    70,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    41,     0,
     0,    10,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    22,    83,    81,    82,    80,    14,     0,     0,
     0,     0,     0,     0,     0,    31,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    13,     0,     0,     0,
     0,     0,     0,     0,    40,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    16,    23,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    24,     0,     0,     0,     0,    30,     0,    15,    32,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    25,     0,
    27,    28,    29,    33,     0,     0,     0,     0,    39,     0,
     0,     0,     0,     0,     0,     0,     0,    34,     0,    36,
    37,    38,     0,     0,     0,     0,     0,     0,    26,     0,
     0,    35,     0,     0,     0
};

static const short yydefgoto[] = {   403,
    20,    21,    22,    23,   223,    76,    93,    24,    95
};

static const short yypact[] = {  1738,
   189,  1817,   -39,   -37,   189,   -10,     7,    17,    41,    54,
    61,    62,    68,    70,-32768,-32768,    72,    91,  1769,    78,
   133,-32768,-32768,  1855,   189,-32768,  1793,-32768,     8,    71,
-32768,   189,   189,   189,   189,   189,   189,   189,   189,   189,
   189,   189,    92,    83,   122,  1564,  1738,  1738,   465,   189,
   103,   189,   189,   189,   189,   189,   189,   -35,   189,   189,
   189,   189,   189,     9,     5,   100,   121,   129,   148,   525,
   546,   552,   573,   579,   600,   152,   606,   627,   633,  1590,
   654,-32768,-32768,   127,   -35,-32768,-32768,   183,   156,   377,
   189,   453,   160,   436,-32768,  1861,   188,    90,    90,   205,
   205,-32768,   205,   176,-32768,  1570,   201,   293,   254,   254,
   -35,-32768,   -35,   307,   189,   189,   189,   189,   189,   189,
   307,   189,   189,   189,-32768,   189,    89,   173,   180,   105,
     3,  1861,   320,    60,   478,   189,   187,    92,   175,   224,
   498,   182,   660,   681,   687,   708,   714,   735,   741,   221,
   762,  1861,   768,   789,  1596,   253,   255,   235,-32768,-32768,
    66,   364,-32768,-32768,   150,   393,-32768,-32768,  1861,-32768,
   270,-32768,   -35,   189,   189,   189,   189,   189,   189,   189,
   -35,   189,   189,   189,-32768,   252,   222,-32768,-32768,-32768,
-32768,-32768,   181,-32768,-32768,-32768,-32768,   286,  1784,   266,
   795,   816,   822,   843,   849,   870,   876,   267,  1861,   897,
   903,-32768,   274,   285,   289,   290,   292,   295,   296,   297,
   298,   299,-32768,-32768,-32768,-32768,-32768,-32768,   -35,   -35,
   189,   189,   189,   189,   189,-32768,   189,   189,   260,   189,
   189,   189,   189,   189,   189,   189,   189,   189,   291,   306,
   924,   930,   951,   957,   978,   984,  1005,   110,  1011,  1032,
  1038,  1059,  1065,  1086,   118,  1092,  1113,   -35,   -35,   -35,
   189,   189,   189,   189,   -35,   189,-32768,   189,   189,   189,
   189,   189,   189,   189,-32768,   189,   189,   189,   316,   321,
   322,  1119,  1140,  1146,  1167,   324,  1173,  1194,  1200,  1221,
  1227,  1248,  1254,  1275,  1281,  1302,-32768,-32768,   -35,   -35,
   189,   -35,   -35,   -35,   -35,   189,   189,   189,   189,   189,
   189,   189,   189,   189,   326,   328,  1308,   329,   330,   332,
   336,  1616,  1622,  1329,  1335,  1356,  1362,  1383,  1389,  1410,
-32768,   -35,   189,   -35,   -35,-32768,   -35,-32768,-32768,   189,
   189,   189,   189,   189,   189,   189,   339,  1416,   343,   345,
   346,  1642,  1437,  1443,  1464,  1470,  1648,  1491,-32768,   189,
-32768,-32768,-32768,-32768,   189,   189,   189,   189,-32768,   189,
  1497,  1668,  1518,  1674,  1694,  1700,   -35,-32768,   189,-32768,
-32768,-32768,   347,  1524,   -35,   189,   349,  1545,-32768,   189,
  1720,-32768,   340,   363,-32768
};

static const short yypgoto[] = {-32768,
    80,   153,-32768,    73,-32768,   145,-32768,    -1,   257
};


#define	YYLAST		1881


static const short yytable[] = {    26,
    29,    16,    30,    31,   104,    52,    53,    54,    55,    56,
    57,    52,    53,    54,    55,    56,    57,    46,    59,    60,
    61,    62,    63,    64,    59,    60,    61,    62,    63,    32,
    70,    71,    72,    73,    74,    75,    77,    78,    79,    80,
    81,    43,    68,    86,   104,   162,    33,    94,    96,    86,
    98,    99,   100,   101,   102,   103,    34,   106,   107,   108,
   109,   110,    52,    53,    54,    55,    56,    57,    52,    53,
    54,    55,    56,    57,    28,    59,    60,    61,    62,    63,
    35,    59,    60,    61,    62,    63,    47,    48,   131,   132,
   134,    47,    48,    36,    54,    55,    56,    57,    44,    67,
    37,    38,   166,   137,   167,    69,   189,    39,     1,    40,
   190,    41,   143,   144,   145,   146,   147,   148,   149,   151,
   152,   153,   154,    83,   155,     5,    87,    88,   161,   156,
    42,   165,    82,    94,   169,    49,    50,    84,    97,    64,
    15,   111,    17,    18,    25,   159,    49,    50,    51,   160,
   277,   278,    52,    53,    54,    55,    56,    57,   285,   286,
   193,   112,   127,    85,   198,    59,    60,    61,    62,    63,
   113,    45,   201,   202,   203,   204,   205,   206,   207,    66,
   209,   210,   211,    52,    53,    54,    55,    56,    57,   114,
   194,    47,     1,   121,   195,   129,    59,    60,    61,    62,
    63,   135,   137,    52,    53,    54,    55,    56,    57,     5,
   105,    56,   138,   157,   158,   171,    59,    66,    61,    62,
    63,   224,   170,   173,    15,   225,    17,    18,    25,   251,
   252,   253,   254,   255,   213,   256,   257,   128,   259,   260,
   261,   262,   263,   264,    77,   266,   267,   214,   215,   216,
   217,   218,   219,   220,   221,   222,    52,    53,    54,    55,
    56,    57,   181,   139,   172,   140,   142,   186,   187,   292,
   293,   294,   295,   150,   297,   188,   298,   299,   300,   301,
   302,   303,   304,   199,   151,   305,   306,   212,    52,    53,
    54,    55,    56,    57,   258,    52,    53,    54,    55,    56,
    57,    59,    60,    61,    62,    63,   228,   236,    59,   327,
     1,    62,    63,   239,   332,   333,   334,   335,   336,   337,
   338,   339,   340,     1,   240,   200,   226,     5,   241,   242,
   227,   243,   268,   208,   244,   245,   246,   247,   248,   404,
     5,   358,    15,    16,    17,    18,   141,   269,   362,   363,
   364,   365,   366,   367,   368,    15,   307,    17,    18,    25,
   163,   308,   405,   309,   164,   314,   341,     1,   381,   342,
   344,   345,   346,   382,   383,   384,   385,   347,   386,   369,
     1,   249,   250,   371,     5,   372,   373,   394,   395,   399,
   265,   168,     0,     0,   398,     0,     1,     5,   401,    15,
     0,    17,    18,    25,   191,     0,     0,     0,   192,     0,
     0,     0,    15,     5,    17,    18,    25,     0,     0,   130,
   289,   290,   291,     0,     0,     0,     0,   296,    15,     0,
    17,    18,    25,   196,     0,     0,     0,   197,    52,    53,
    54,    55,    56,    57,     0,     0,     0,     0,     0,     0,
     0,    59,    60,    61,    62,    63,     1,     0,     0,     0,
     0,   325,   326,     0,   328,   329,   330,   331,     1,     0,
     0,     0,     0,     5,     0,     0,    89,     0,   136,     0,
     0,     1,     0,     0,     0,     5,     0,     0,    15,     0,
    17,    18,    25,     0,   357,   133,   359,   360,     5,   361,
    15,     1,    17,    18,    90,     0,     0,    91,    92,     0,
     0,     0,     0,    15,     0,    17,    18,    90,     5,     0,
    91,    92,     0,     0,     0,     0,     0,    52,    53,    54,
    55,    56,    57,    15,   138,    17,    18,    25,     0,   393,
    59,    60,    61,    62,    63,     0,     0,   397,    52,    53,
    54,    55,    56,    57,    52,    53,    54,    55,    56,    57,
     0,    59,    60,    61,    62,    63,   115,    59,    60,    61,
    62,    63,     0,     0,     0,    52,    53,    54,    55,    56,
    57,    52,    53,    54,    55,    56,    57,   116,    59,    60,
    61,    62,    63,   117,    59,    60,    61,    62,    63,     0,
     0,     0,    52,    53,    54,    55,    56,    57,    52,    53,
    54,    55,    56,    57,   118,    59,    60,    61,    62,    63,
   119,    59,    60,    61,    62,    63,     0,     0,     0,    52,
    53,    54,    55,    56,    57,    52,    53,    54,    55,    56,
    57,   120,    59,    60,    61,    62,    63,   122,    59,    60,
    61,    62,    63,     0,     0,     0,    52,    53,    54,    55,
    56,    57,    52,    53,    54,    55,    56,    57,   123,    59,
    60,    61,    62,    63,   124,    59,    60,    61,    62,    63,
     0,     0,     0,    52,    53,    54,    55,    56,    57,    52,
    53,    54,    55,    56,    57,   126,    59,    60,    61,    62,
    63,   174,    59,    60,    61,    62,    63,     0,     0,     0,
    52,    53,    54,    55,    56,    57,    52,    53,    54,    55,
    56,    57,   175,    59,    60,    61,    62,    63,   176,    59,
    60,    61,    62,    63,     0,     0,     0,    52,    53,    54,
    55,    56,    57,    52,    53,    54,    55,    56,    57,   177,
    59,    60,    61,    62,    63,   178,    59,    60,    61,    62,
    63,     0,     0,     0,    52,    53,    54,    55,    56,    57,
    52,    53,    54,    55,    56,    57,   179,    59,    60,    61,
    62,    63,   180,    59,    60,    61,    62,    63,     0,     0,
     0,    52,    53,    54,    55,    56,    57,    52,    53,    54,
    55,    56,    57,   182,    59,    60,    61,    62,    63,   183,
    59,    60,    61,    62,    63,     0,     0,     0,    52,    53,
    54,    55,    56,    57,    52,    53,    54,    55,    56,    57,
   184,    59,    60,    61,    62,    63,   229,    59,    60,    61,
    62,    63,     0,     0,     0,    52,    53,    54,    55,    56,
    57,    52,    53,    54,    55,    56,    57,   230,    59,    60,
    61,    62,    63,   231,    59,    60,    61,    62,    63,     0,
     0,     0,    52,    53,    54,    55,    56,    57,    52,    53,
    54,    55,    56,    57,   232,    59,    60,    61,    62,    63,
   233,    59,    60,    61,    62,    63,     0,     0,     0,    52,
    53,    54,    55,    56,    57,    52,    53,    54,    55,    56,
    57,   234,    59,    60,    61,    62,    63,   235,    59,    60,
    61,    62,    63,     0,     0,     0,    52,    53,    54,    55,
    56,    57,    52,    53,    54,    55,    56,    57,   237,    59,
    60,    61,    62,    63,   238,    59,    60,    61,    62,    63,
     0,     0,     0,    52,    53,    54,    55,    56,    57,    52,
    53,    54,    55,    56,    57,   270,    59,    60,    61,    62,
    63,   271,    59,    60,    61,    62,    63,     0,     0,     0,
    52,    53,    54,    55,    56,    57,    52,    53,    54,    55,
    56,    57,   272,    59,    60,    61,    62,    63,   273,    59,
    60,    61,    62,    63,     0,     0,     0,    52,    53,    54,
    55,    56,    57,    52,    53,    54,    55,    56,    57,   274,
    59,    60,    61,    62,    63,   275,    59,    60,    61,    62,
    63,     0,     0,     0,    52,    53,    54,    55,    56,    57,
    52,    53,    54,    55,    56,    57,   276,    59,    60,    61,
    62,    63,   279,    59,    60,    61,    62,    63,     0,     0,
     0,    52,    53,    54,    55,    56,    57,    52,    53,    54,
    55,    56,    57,   280,    59,    60,    61,    62,    63,   281,
    59,    60,    61,    62,    63,     0,     0,     0,    52,    53,
    54,    55,    56,    57,    52,    53,    54,    55,    56,    57,
   282,    59,    60,    61,    62,    63,   283,    59,    60,    61,
    62,    63,     0,     0,     0,    52,    53,    54,    55,    56,
    57,    52,    53,    54,    55,    56,    57,   284,    59,    60,
    61,    62,    63,   287,    59,    60,    61,    62,    63,     0,
     0,     0,    52,    53,    54,    55,    56,    57,    52,    53,
    54,    55,    56,    57,   288,    59,    60,    61,    62,    63,
   310,    59,    60,    61,    62,    63,     0,     0,     0,    52,
    53,    54,    55,    56,    57,    52,    53,    54,    55,    56,
    57,   311,    59,    60,    61,    62,    63,   312,    59,    60,
    61,    62,    63,     0,     0,     0,    52,    53,    54,    55,
    56,    57,    52,    53,    54,    55,    56,    57,   313,    59,
    60,    61,    62,    63,   315,    59,    60,    61,    62,    63,
     0,     0,     0,    52,    53,    54,    55,    56,    57,    52,
    53,    54,    55,    56,    57,   316,    59,    60,    61,    62,
    63,   317,    59,    60,    61,    62,    63,     0,     0,     0,
    52,    53,    54,    55,    56,    57,    52,    53,    54,    55,
    56,    57,   318,    59,    60,    61,    62,    63,   319,    59,
    60,    61,    62,    63,     0,     0,     0,    52,    53,    54,
    55,    56,    57,    52,    53,    54,    55,    56,    57,   320,
    59,    60,    61,    62,    63,   321,    59,    60,    61,    62,
    63,     0,     0,     0,    52,    53,    54,    55,    56,    57,
    52,    53,    54,    55,    56,    57,   322,    59,    60,    61,
    62,    63,   323,    59,    60,    61,    62,    63,     0,     0,
     0,    52,    53,    54,    55,    56,    57,    52,    53,    54,
    55,    56,    57,   324,    59,    60,    61,    62,    63,   343,
    59,    60,    61,    62,    63,     0,     0,     0,    52,    53,
    54,    55,    56,    57,    52,    53,    54,    55,    56,    57,
   350,    59,    60,    61,    62,    63,   351,    59,    60,    61,
    62,    63,     0,     0,     0,    52,    53,    54,    55,    56,
    57,    52,    53,    54,    55,    56,    57,   352,    59,    60,
    61,    62,    63,   353,    59,    60,    61,    62,    63,     0,
     0,     0,    52,    53,    54,    55,    56,    57,    52,    53,
    54,    55,    56,    57,   354,    59,    60,    61,    62,    63,
   355,    59,    60,    61,    62,    63,     0,     0,     0,    52,
    53,    54,    55,    56,    57,    52,    53,    54,    55,    56,
    57,   356,    59,    60,    61,    62,    63,   370,    59,    60,
    61,    62,    63,     0,     0,     0,    52,    53,    54,    55,
    56,    57,    52,    53,    54,    55,    56,    57,   375,    59,
    60,    61,    62,    63,   376,    59,    60,    61,    62,    63,
     0,     0,     0,    52,    53,    54,    55,    56,    57,    52,
    53,    54,    55,    56,    57,   377,    59,    60,    61,    62,
    63,   378,    59,    60,    61,    62,    63,     0,     0,     0,
    52,    53,    54,    55,    56,    57,    52,    53,    54,    55,
    56,    57,   380,    59,    60,    61,    62,    63,   387,    59,
    60,    61,    62,    63,     0,     0,     0,    52,    53,    54,
    55,    56,    57,     0,     0,     0,     0,     0,     0,   389,
    59,    60,    61,    62,    63,   396,    52,    53,    54,    55,
    56,    57,    52,    53,    54,    55,    56,    57,    58,    59,
    60,    61,    62,    63,     0,     0,   400,     0,    62,    63,
     0,     0,    52,    53,    54,    55,    56,    57,    52,    53,
    54,    55,    56,    57,    86,    59,    60,    61,    62,    63,
     0,    59,    60,    61,    62,    63,     0,     0,    52,    53,
    54,    55,    56,    57,    52,    53,    54,    55,    56,    57,
   125,    59,    60,    61,    62,    63,   185,    59,    60,    61,
    62,    63,     0,     0,    52,    53,    54,    55,    56,    57,
    52,    53,    54,    55,    56,    57,   348,    59,    60,    61,
    62,    63,   349,    59,    60,    61,    62,    63,     0,     0,
    52,    53,    54,    55,    56,    57,    52,    53,    54,    55,
    56,    57,   374,    59,    60,    61,    62,    63,   379,    59,
    60,    61,    62,    63,     0,     0,    52,    53,    54,    55,
    56,    57,    52,    53,    54,    55,    56,    57,   388,    59,
    60,    61,    62,    63,   390,    59,    60,    61,    62,    63,
     0,     0,    52,    53,    54,    55,    56,    57,     0,     0,
     0,     0,     0,     0,   391,    59,    60,    61,    62,    63,
   392,     1,     0,     0,     0,     0,     0,     0,     2,     3,
     4,     0,     0,     0,     0,     0,     0,     0,     5,     0,
   402,     0,     0,     6,     7,     8,     9,    10,    11,    12,
    13,    14,     1,    15,    16,    17,    18,    19,     0,     2,
     3,     4,     0,     0,     0,     0,     0,     0,     0,     5,
     0,     0,     0,     0,     6,     7,     8,     9,    10,    11,
    12,    13,    14,     2,    15,    43,    17,    18,    19,   214,
   215,   216,   217,   218,   219,   220,   221,   222,     6,     7,
     8,     9,    10,    11,    12,    13,    14,     2,     0,    16,
     0,     0,    65,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     6,     7,     8,     9,    10,    11,    12,    13,
    14,     0,     0,     0,     0,     0,    27,    52,    53,    54,
    55,    56,    57,    52,    53,    54,    55,    56,    57,    58,
    59,    60,    61,    62,    63,     0,    59,    60,    61,    62,
    63
};

static const short yycheck[] = {     1,
    40,    37,    40,     5,    40,     3,     4,     5,     6,     7,
     8,     3,     4,     5,     6,     7,     8,    19,    16,    17,
    18,    19,    20,    25,    16,    17,    18,    19,    20,    40,
    32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
    42,    37,    35,    41,    40,    43,    40,    49,    50,    41,
    52,    53,    54,    55,    56,    57,    40,    59,    60,    61,
    62,    63,     3,     4,     5,     6,     7,     8,     3,     4,
     5,     6,     7,     8,     2,    16,    17,    18,    19,    20,
    40,    16,    17,    18,    19,    20,     9,    10,    90,    91,
    92,     9,    10,    40,     5,     6,     7,     8,    19,    27,
    40,    40,    43,    15,    45,    35,    41,    40,     4,    40,
    45,    40,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,    41,   126,    21,    47,    48,   130,    41,
    40,   133,    41,   135,   136,    14,    15,    16,    36,   141,
    36,    42,    38,    39,    40,    41,    14,    15,    16,    45,
    41,    42,     3,     4,     5,     6,     7,     8,    41,    42,
   162,    41,    36,    42,   166,    16,    17,    18,    19,    20,
    42,    19,   174,   175,   176,   177,   178,   179,   180,    27,
   182,   183,   184,     3,     4,     5,     6,     7,     8,    42,
    41,     9,     4,    42,    45,    40,    16,    17,    18,    19,
    20,    42,    15,     3,     4,     5,     6,     7,     8,    21,
    58,     7,    37,    41,    35,    41,    16,    65,    18,    19,
    20,    41,    36,    42,    36,    45,    38,    39,    40,   231,
   232,   233,   234,   235,    13,   237,   238,    85,   240,   241,
   242,   243,   244,   245,   246,   247,   248,    26,    27,    28,
    29,    30,    31,    32,    33,    34,     3,     4,     5,     6,
     7,     8,    42,   111,    41,   113,   114,    15,    14,   271,
   272,   273,   274,   121,   276,    41,   278,   279,   280,   281,
   282,   283,   284,    14,   286,   287,   288,    36,     3,     4,
     5,     6,     7,     8,    35,     3,     4,     5,     6,     7,
     8,    16,    17,    18,    19,    20,    41,    41,    16,   311,
     4,    19,    20,    40,   316,   317,   318,   319,   320,   321,
   322,   323,   324,     4,    40,   173,    41,    21,    40,    40,
    45,    40,    42,   181,    40,    40,    40,    40,    40,     0,
    21,   343,    36,    37,    38,    39,    40,    42,   350,   351,
   352,   353,   354,   355,   356,    36,    41,    38,    39,    40,
    41,    41,     0,    42,    45,    42,    41,     4,   370,    42,
    42,    42,    41,   375,   376,   377,   378,    42,   380,    41,
     4,   229,   230,    41,    21,    41,    41,   389,    42,    41,
   246,   135,    -1,    -1,   396,    -1,     4,    21,   400,    36,
    -1,    38,    39,    40,    41,    -1,    -1,    -1,    45,    -1,
    -1,    -1,    36,    21,    38,    39,    40,    -1,    -1,    43,
   268,   269,   270,    -1,    -1,    -1,    -1,   275,    36,    -1,
    38,    39,    40,    41,    -1,    -1,    -1,    45,     3,     4,
     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    16,    17,    18,    19,    20,     4,    -1,    -1,    -1,
    -1,   309,   310,    -1,   312,   313,   314,   315,     4,    -1,
    -1,    -1,    -1,    21,    -1,    -1,    12,    -1,    43,    -1,
    -1,     4,    -1,    -1,    -1,    21,    -1,    -1,    36,    -1,
    38,    39,    40,    -1,   342,    43,   344,   345,    21,   347,
    36,     4,    38,    39,    40,    -1,    -1,    43,    44,    -1,
    -1,    -1,    -1,    36,    -1,    38,    39,    40,    21,    -1,
    43,    44,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
     6,     7,     8,    36,    37,    38,    39,    40,    -1,   387,
    16,    17,    18,    19,    20,    -1,    -1,   395,     3,     4,
     5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
    -1,    16,    17,    18,    19,    20,    42,    16,    17,    18,
    19,    20,    -1,    -1,    -1,     3,     4,     5,     6,     7,
     8,     3,     4,     5,     6,     7,     8,    42,    16,    17,
    18,    19,    20,    42,    16,    17,    18,    19,    20,    -1,
    -1,    -1,     3,     4,     5,     6,     7,     8,     3,     4,
     5,     6,     7,     8,    42,    16,    17,    18,    19,    20,
    42,    16,    17,    18,    19,    20,    -1,    -1,    -1,     3,
     4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
     8,    42,    16,    17,    18,    19,    20,    42,    16,    17,
    18,    19,    20,    -1,    -1,    -1,     3,     4,     5,     6,
     7,     8,     3,     4,     5,     6,     7,     8,    42,    16,
    17,    18,    19,    20,    42,    16,    17,    18,    19,    20,
    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     3,
     4,     5,     6,     7,     8,    42,    16,    17,    18,    19,
    20,    42,    16,    17,    18,    19,    20,    -1,    -1,    -1,
     3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
     7,     8,    42,    16,    17,    18,    19,    20,    42,    16,
    17,    18,    19,    20,    -1,    -1,    -1,     3,     4,     5,
     6,     7,     8,     3,     4,     5,     6,     7,     8,    42,
    16,    17,    18,    19,    20,    42,    16,    17,    18,    19,
    20,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
     3,     4,     5,     6,     7,     8,    42,    16,    17,    18,
    19,    20,    42,    16,    17,    18,    19,    20,    -1,    -1,
    -1,     3,     4,     5,     6,     7,     8,     3,     4,     5,
     6,     7,     8,    42,    16,    17,    18,    19,    20,    42,
    16,    17,    18,    19,    20,    -1,    -1,    -1,     3,     4,
     5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
    42,    16,    17,    18,    19,    20,    42,    16,    17,    18,
    19,    20,    -1,    -1,    -1,     3,     4,     5,     6,     7,
     8,     3,     4,     5,     6,     7,     8,    42,    16,    17,
    18,    19,    20,    42,    16,    17,    18,    19,    20,    -1,
    -1,    -1,     3,     4,     5,     6,     7,     8,     3,     4,
     5,     6,     7,     8,    42,    16,    17,    18,    19,    20,
    42,    16,    17,    18,    19,    20,    -1,    -1,    -1,     3,
     4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
     8,    42,    16,    17,    18,    19,    20,    42,    16,    17,
    18,    19,    20,    -1,    -1,    -1,     3,     4,     5,     6,
     7,     8,     3,     4,     5,     6,     7,     8,    42,    16,
    17,    18,    19,    20,    42,    16,    17,    18,    19,    20,
    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     3,
     4,     5,     6,     7,     8,    42,    16,    17,    18,    19,
    20,    42,    16,    17,    18,    19,    20,    -1,    -1,    -1,
     3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
     7,     8,    42,    16,    17,    18,    19,    20,    42,    16,
    17,    18,    19,    20,    -1,    -1,    -1,     3,     4,     5,
     6,     7,     8,     3,     4,     5,     6,     7,     8,    42,
    16,    17,    18,    19,    20,    42,    16,    17,    18,    19,
    20,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
     3,     4,     5,     6,     7,     8,    42,    16,    17,    18,
    19,    20,    42,    16,    17,    18,    19,    20,    -1,    -1,
    -1,     3,     4,     5,     6,     7,     8,     3,     4,     5,
     6,     7,     8,    42,    16,    17,    18,    19,    20,    42,
    16,    17,    18,    19,    20,    -1,    -1,    -1,     3,     4,
     5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
    42,    16,    17,    18,    19,    20,    42,    16,    17,    18,
    19,    20,    -1,    -1,    -1,     3,     4,     5,     6,     7,
     8,     3,     4,     5,     6,     7,     8,    42,    16,    17,
    18,    19,    20,    42,    16,    17,    18,    19,    20,    -1,
    -1,    -1,     3,     4,     5,     6,     7,     8,     3,     4,
     5,     6,     7,     8,    42,    16,    17,    18,    19,    20,
    42,    16,    17,    18,    19,    20,    -1,    -1,    -1,     3,
     4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
     8,    42,    16,    17,    18,    19,    20,    42,    16,    17,
    18,    19,    20,    -1,    -1,    -1,     3,     4,     5,     6,
     7,     8,     3,     4,     5,     6,     7,     8,    42,    16,
    17,    18,    19,    20,    42,    16,    17,    18,    19,    20,
    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     3,
     4,     5,     6,     7,     8,    42,    16,    17,    18,    19,
    20,    42,    16,    17,    18,    19,    20,    -1,    -1,    -1,
     3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
     7,     8,    42,    16,    17,    18,    19,    20,    42,    16,
    17,    18,    19,    20,    -1,    -1,    -1,     3,     4,     5,
     6,     7,     8,     3,     4,     5,     6,     7,     8,    42,
    16,    17,    18,    19,    20,    42,    16,    17,    18,    19,
    20,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
     3,     4,     5,     6,     7,     8,    42,    16,    17,    18,
    19,    20,    42,    16,    17,    18,    19,    20,    -1,    -1,
    -1,     3,     4,     5,     6,     7,     8,     3,     4,     5,
     6,     7,     8,    42,    16,    17,    18,    19,    20,    42,
    16,    17,    18,    19,    20,    -1,    -1,    -1,     3,     4,
     5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
    42,    16,    17,    18,    19,    20,    42,    16,    17,    18,
    19,    20,    -1,    -1,    -1,     3,     4,     5,     6,     7,
     8,     3,     4,     5,     6,     7,     8,    42,    16,    17,
    18,    19,    20,    42,    16,    17,    18,    19,    20,    -1,
    -1,    -1,     3,     4,     5,     6,     7,     8,     3,     4,
     5,     6,     7,     8,    42,    16,    17,    18,    19,    20,
    42,    16,    17,    18,    19,    20,    -1,    -1,    -1,     3,
     4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
     8,    42,    16,    17,    18,    19,    20,    42,    16,    17,
    18,    19,    20,    -1,    -1,    -1,     3,     4,     5,     6,
     7,     8,     3,     4,     5,     6,     7,     8,    42,    16,
    17,    18,    19,    20,    42,    16,    17,    18,    19,    20,
    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     3,
     4,     5,     6,     7,     8,    42,    16,    17,    18,    19,
    20,    42,    16,    17,    18,    19,    20,    -1,    -1,    -1,
     3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
     7,     8,    42,    16,    17,    18,    19,    20,    42,    16,
    17,    18,    19,    20,    -1,    -1,    -1,     3,     4,     5,
     6,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    42,
    16,    17,    18,    19,    20,    42,     3,     4,     5,     6,
     7,     8,     3,     4,     5,     6,     7,     8,    15,    16,
    17,    18,    19,    20,    -1,    -1,    42,    -1,    19,    20,
    -1,    -1,     3,     4,     5,     6,     7,     8,     3,     4,
     5,     6,     7,     8,    41,    16,    17,    18,    19,    20,
    -1,    16,    17,    18,    19,    20,    -1,    -1,     3,     4,
     5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
    41,    16,    17,    18,    19,    20,    41,    16,    17,    18,
    19,    20,    -1,    -1,     3,     4,     5,     6,     7,     8,
     3,     4,     5,     6,     7,     8,    41,    16,    17,    18,
    19,    20,    41,    16,    17,    18,    19,    20,    -1,    -1,
     3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
     7,     8,    41,    16,    17,    18,    19,    20,    41,    16,
    17,    18,    19,    20,    -1,    -1,     3,     4,     5,     6,
     7,     8,     3,     4,     5,     6,     7,     8,    41,    16,
    17,    18,    19,    20,    41,    16,    17,    18,    19,    20,
    -1,    -1,     3,     4,     5,     6,     7,     8,    -1,    -1,
    -1,    -1,    -1,    -1,    41,    16,    17,    18,    19,    20,
    41,     4,    -1,    -1,    -1,    -1,    -1,    -1,    11,    12,
    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,    -1,
    41,    -1,    -1,    26,    27,    28,    29,    30,    31,    32,
    33,    34,     4,    36,    37,    38,    39,    40,    -1,    11,
    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,
    -1,    -1,    -1,    -1,    26,    27,    28,    29,    30,    31,
    32,    33,    34,    11,    36,    37,    38,    39,    40,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    26,    27,
    28,    29,    30,    31,    32,    33,    34,    11,    -1,    37,
    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    26,    27,    28,    29,    30,    31,    32,    33,
    34,    -1,    -1,    -1,    -1,    -1,    40,     3,     4,     5,
     6,     7,     8,     3,     4,     5,     6,     7,     8,    15,
    16,    17,    18,    19,    20,    -1,    16,    17,    18,    19,
    20
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/share/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/local/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
#line 104 "DssParser.y"
{ dssBuilder.andDss(); ;
    break;}
case 4:
#line 105 "DssParser.y"
{ dssBuilder.orDss(); ;
    break;}
case 5:
#line 106 "DssParser.y"
{ dssBuilder.newDss(); ;
    break;}
case 6:
#line 108 "DssParser.y"
{ yyval.yAxisName = yyvsp[0].yAxisName; ;
    break;}
case 7:
#line 109 "DssParser.y"
{ yyval.yAxisName = yyvsp[-1].yAxisName; ;
    break;}
case 8:
#line 112 "DssParser.y"
{ if(yyFilteredTable){
                                    const Column *ctemp = yyFilteredTable->column(*yyvsp[-2].yAxisName);
                                    dssBuilder.currentComponent()->
                                            addFilter(ctemp, *yyvsp[0].yRangeList);
                                  }else{
                                    dssBuilder.currentComponent()->
                                            addFilter(*yyvsp[-2].yAxisName, *yyvsp[0].yRangeList);
                                  }
                                  delete yyvsp[-2].yAxisName;
                                  delete yyvsp[0].yRangeList; 
                                ;
    break;}
case 9:
#line 124 "DssParser.y"
{ if( yyvsp[-1].yRelOp != EqOpT || yyvsp[0].yNumber != 0 ){
				    selerrstr<<"Bit mask filter must be tested against \"== 0\"."
					     <<selerror("BitMaskTesting");
  				    SELTHROW(DssBuilder::MiscException);
				  }
				  if(yyFilteredTable){
                                    const Column *ctemp = yyFilteredTable->column(*yyvsp[-4].yAxisName);
                                    dssBuilder.currentComponent()->
                                           addFilter(ctemp, ULNG(yyvsp[-2].yNumber));
                                  }else{
                                    dssBuilder.currentComponent()->
                                            addFilter(*yyvsp[-4].yAxisName, ULNG(yyvsp[-2].yNumber));
                                  }
                                  delete yyvsp[-4].yAxisName;
                                ;
    break;}
case 10:
#line 140 "DssParser.y"
{ if( yyvsp[-1].yRelOp != EqOpT || yyvsp[0].yNumber != 0 ){
				    selerrstr<<"Bit mask filter must be tested against \" == 0\"."
					     <<selerror("MaskSpecOffset");
  				    SELTHROW(DssBuilder::MiscException);
				  }
				  if(yyFilteredTable){
                                    const Column *ctemp = yyFilteredTable->column(*yyvsp[-5].yAxisName);
                                    dssBuilder.currentComponent()->
                                           addFilter(ctemp, ULNG(yyvsp[-3].yNumber));
                                  }else{
                                    dssBuilder.currentComponent()->
                                            addFilter(*yyvsp[-5].yAxisName, ULNG(yyvsp[-3].yNumber));
                                  }
                                  delete yyvsp[-5].yAxisName;
                                ;
    break;}
case 11:
#line 156 "DssParser.y"
{ if(yyFilteredTable){
                                    const Column *ctemp = yyFilteredTable->column(*yyvsp[-5].yAxisName);
                                    dssBuilder.currentComponent()->
                                           addFilter(ctemp, *yyvsp[-1].yBlockSpec);
                                  }else{
                                    dssBuilder.currentComponent()->
                                            addFilter(*yyvsp[-5].yAxisName, *yyvsp[-1].yBlockSpec);
                                  }
                                  delete yyvsp[-5].yAxisName;
                                  delete yyvsp[-1].yBlockSpec;
                                ;
    break;}
case 12:
#line 168 "DssParser.y"
{ if(yyFilteredTable){
                                    const Column *ctemp = yyFilteredTable->column(*yyvsp[-1].yAxisName);
                                    dssBuilder.currentComponent()->
                                            addFilter(ctemp, *yyvsp[-3].yBlockSpec);
                                  }else{
                                    dssBuilder.currentComponent()->
                                            addFilter(*yyvsp[-1].yAxisName, *yyvsp[-3].yBlockSpec);
                                  }
                                  delete yyvsp[-3].yBlockSpec;
                                  delete yyvsp[-1].yAxisName;
                                ;
    break;}
case 13:
#line 180 "DssParser.y"
{ DSS::DSfilterComp fcomp(2);
                                  fcomp[0] = *yyvsp[-8].yAxisName;
                                  fcomp[1] = *yyvsp[-6].yAxisName;
                                  dssBuilder.currentComponent()->
                                           addFilter(dssBuilder.Axis2dName(fcomp), *yyvsp[-1].yBlockSpec, fcomp);
                                  delete yyvsp[-8].yAxisName;
                                  delete yyvsp[-6].yAxisName;
                                ;
    break;}
case 14:
#line 189 "DssParser.y"
{ DSS::DSfilterComp fcomp(2);
                                  fcomp[0] = *yyvsp[-3].yAxisName;
                                  fcomp[1] = *yyvsp[-1].yAxisName;
                                  dssBuilder.currentComponent()->
                                           addFilter(dssBuilder.Axis2dName(fcomp), *yyvsp[-5].yBlockSpec, fcomp);
                                  delete yyvsp[-3].yAxisName;
                                  delete yyvsp[-1].yAxisName;
                                ;
    break;}
case 15:
#line 198 "DssParser.y"
{ if( yyvsp[-3].yNumber != 0 || yyvsp[-1].yNumber != 0 ){
				    selerrstr<<"Mask filter must have zero offset in the data subspace."
					     <<selerror("MaskSpecOffset");
  				    SELTHROW(DssBuilder::MiscException);
				  }
				  DSS::DSfilterComp fcomp(2);
                                  fcomp[0] = *yyvsp[-12].yAxisName;
                                  fcomp[1] = *yyvsp[-10].yAxisName;
                                  dssBuilder.currentComponent()->
                                           addFilter(dssBuilder.Axis2dName(fcomp), *yyvsp[-5].yBlockSpec, fcomp);
                                  delete yyvsp[-12].yAxisName;
                                  delete yyvsp[-10].yAxisName;
                                ;
    break;}
case 16:
#line 212 "DssParser.y"
{ if( yyvsp[-7].yNumber != 0 || yyvsp[-5].yNumber != 0 ){
				    selerrstr<<"Mask filter must have zero offset in the data subspace."
					     <<selerror("MaskSpecOffset");
  				    SELTHROW(DssBuilder::MiscException);
				  }
				  DSS::DSfilterComp fcomp(2);
                                  fcomp[0] = *yyvsp[-3].yAxisName;
                                  fcomp[1] = *yyvsp[-1].yAxisName;
                                  dssBuilder.currentComponent()->
                                           addFilter(dssBuilder.Axis2dName(fcomp), *yyvsp[-9].yBlockSpec, fcomp);
                                  delete yyvsp[-3].yAxisName;
                                  delete yyvsp[-1].yAxisName;
                                ;
    break;}
case 17:
#line 226 "DssParser.y"
{ DRangeList rlist;
				  switch (yyvsp[-1].yRelOp) {
				  case LtOpT:{
				    DRange range(-DBL_MAX, yyvsp[0].yNumber, Unbounded, Open);
				    rlist.push_back(range);
				    break; }
				  case LeOpT:{
				    DRange range(-DBL_MAX, yyvsp[0].yNumber, Unbounded, Closed);
				    rlist.push_back(range);
				    break; }
				  case GtOpT:{
				    DRange range(yyvsp[0].yNumber, DBL_MAX, Open, Unbounded);
				    rlist.push_back(range);
				    break; }
				  case GeOpT:{
				    DRange range(yyvsp[0].yNumber, DBL_MAX, Closed, Unbounded);
				    rlist.push_back(range);
				    break; }
				  case EqOpT:{
				    DRange range(yyvsp[0].yNumber, yyvsp[0].yNumber, Closed, Closed);
				    rlist.push_back(range);
				    break; }
				  case NeOpT:{
				    DRange range1(yyvsp[0].yNumber, DBL_MAX, Open, Unbounded);
				    DRange range2(-DBL_MAX, yyvsp[0].yNumber, Unbounded, Open);
				    rlist.push_back(range1);
				    rlist.push_back(range2);
				    break; }
				  }

				  if(yyFilteredTable){
				    const Column *ctemp = yyFilteredTable->column(*yyvsp[-2].yAxisName);
				    dssBuilder.currentComponent()->
				                   addFilter(ctemp, rlist);
				  }else{
				    dssBuilder.currentComponent()->
				                   addFilter(*yyvsp[-2].yAxisName, rlist);
				  }

                                  delete yyvsp[-2].yAxisName;
				;
    break;}
case 18:
#line 268 "DssParser.y"
{ DRangeList rlist;
				  switch (yyvsp[-1].yRelOp) {
				  case GtOpT:{
				    DRange range(-DBL_MAX, yyvsp[-2].yNumber, Unbounded, Open);
				    rlist.push_back(range);
				    break; }
				  case GeOpT:{
				    DRange range(-DBL_MAX, yyvsp[-2].yNumber, Unbounded, Closed);
				    rlist.push_back(range);
				    break; }
				  case LtOpT:{
				    DRange range(yyvsp[-2].yNumber, DBL_MAX, Open, Unbounded);
				    rlist.push_back(range);
				    break; }
				  case LeOpT:{
				    DRange range(yyvsp[-2].yNumber, DBL_MAX, Closed, Unbounded);
				    rlist.push_back(range);
				    break; }
				  case EqOpT:{
				    DRange range(yyvsp[-2].yNumber, yyvsp[-2].yNumber, Closed, Closed);
				    rlist.push_back(range);
				    break; }
                                  case NeOpT:{
				    DRange range1(yyvsp[-2].yNumber, DBL_MAX, Open, Unbounded);
				    DRange range2(-DBL_MAX, yyvsp[-2].yNumber, Unbounded, Open);
				    rlist.push_back(range1);
				    rlist.push_back(range2);
				    break; }
				  }

				  if(yyFilteredTable){
				    const Column *ctemp = yyFilteredTable->column(*yyvsp[0].yAxisName);
				    dssBuilder.currentComponent()->
				                   addFilter(ctemp, rlist);
				  }else{
				    dssBuilder.currentComponent()->
				                   addFilter(*yyvsp[0].yAxisName, rlist);
				  }
                                  delete yyvsp[0].yAxisName;
				;
    break;}
case 19:
#line 309 "DssParser.y"
{ GeoRegion r;
                                  r.push_back(
                                        *dssBuilder.currentRegionComponent());
                                  DSS::DSfilterComp fc(2);
                                  fc[0] = dssBuilder.xAxisName();
                                  fc[1] = dssBuilder.yAxisName();
                                  dssBuilder.currentComponent()->
                                          addFilter(dssBuilder.Axis2dName(fc), r, fc);
                                ;
    break;}
case 20:
#line 319 "DssParser.y"
{ dssBuilder.currentRegion()->
                                         include( !dssBuilder.currentRegion()->included() ); ;
    break;}
case 21:
#line 321 "DssParser.y"
{ dssBuilder.currentRegion()->exclude(); ;
    break;}
case 22:
#line 323 "DssParser.y"
{ dssBuilder.regionAxes(*yyvsp[-5].yAxisName, *yyvsp[-3].yAxisName);
                                  delete yyvsp[-5].yAxisName; delete yyvsp[-3].yAxisName; ;
    break;}
case 23:
#line 326 "DssParser.y"
{ dssBuilder.addRegion(new FCircle(FPoint(yyvsp[-9].yNumber, yyvsp[-7].yNumber), yyvsp[-5].yNumber));
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  ;
    break;}
case 24:
#line 331 "DssParser.y"
{ dssBuilder.addRegion(new FAnnulus(FPoint(yyvsp[-11].yNumber, yyvsp[-9].yNumber), yyvsp[-7].yNumber, yyvsp[-5].yNumber)); 
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  ;
    break;}
case 25:
#line 336 "DssParser.y"
{ dssBuilder.addRegion(new FEllipse(FPoint(yyvsp[-13].yNumber, yyvsp[-11].yNumber), yyvsp[-9].yNumber, yyvsp[-7].yNumber, yyvsp[-5].yNumber));
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  ;
    break;}
case 26:
#line 341 "DssParser.y"
{ dssBuilder.addRegion(new FElliptAnnulus(FPoint(yyvsp[-19].yNumber, yyvsp[-17].yNumber), yyvsp[-15].yNumber, yyvsp[-13].yNumber, yyvsp[-11].yNumber, yyvsp[-9].yNumber, yyvsp[-7].yNumber, yyvsp[-5].yNumber)); 
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  ;
    break;}
case 27:
#line 346 "DssParser.y"
{ dssBuilder.addRegion(new FRotBox(FPoint(yyvsp[-13].yNumber, yyvsp[-11].yNumber), yyvsp[-9].yNumber, yyvsp[-7].yNumber, yyvsp[-5].yNumber));
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  ;
    break;}
case 28:
#line 351 "DssParser.y"
{ dssBuilder.addRegion(new FRotRectangle(FPoint(yyvsp[-13].yNumber, yyvsp[-11].yNumber), yyvsp[-9].yNumber, yyvsp[-7].yNumber, yyvsp[-5].yNumber));
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  ;
    break;}
case 29:
#line 356 "DssParser.y"
{ dssBuilder.addRegion(new FRotRhombus(FPoint(yyvsp[-13].yNumber, yyvsp[-11].yNumber), yyvsp[-9].yNumber, yyvsp[-7].yNumber, yyvsp[-5].yNumber));
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  ;
    break;}
case 30:
#line 361 "DssParser.y"
{ dssBuilder.addRegion(new FSector(FPoint(yyvsp[-11].yNumber, yyvsp[-9].yNumber), yyvsp[-7].yNumber, yyvsp[-5].yNumber)); 
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  ;
    break;}
case 31:
#line 366 "DssParser.y"
{ dssBuilder.addRegion(new FPolygon(yyvsp[-5].yPointList[0], yyvsp[-5].yPointList[1], yyvsp[-5].yPointList[0].size()));
                    delete [] yyvsp[-5].yPointList; 
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  ;
    break;}
case 32:
#line 373 "DssParser.y"
{ dssBuilder.addRegion(new FCircle(FPoint(yyvsp[-5].yNumber, yyvsp[-3].yNumber), yyvsp[-1].yNumber)); 
	  ;
    break;}
case 33:
#line 376 "DssParser.y"
{ dssBuilder.addRegion(new FAnnulus(FPoint(yyvsp[-7].yNumber, yyvsp[-5].yNumber), yyvsp[-3].yNumber, yyvsp[-1].yNumber)); 
	  ;
    break;}
case 34:
#line 379 "DssParser.y"
{ dssBuilder.addRegion(new FEllipse(FPoint(yyvsp[-9].yNumber, yyvsp[-7].yNumber), yyvsp[-5].yNumber, yyvsp[-3].yNumber, yyvsp[-1].yNumber));
	  ;
    break;}
case 35:
#line 382 "DssParser.y"
{ dssBuilder.addRegion(new FElliptAnnulus(FPoint(yyvsp[-15].yNumber, yyvsp[-13].yNumber), yyvsp[-11].yNumber, yyvsp[-9].yNumber, yyvsp[-7].yNumber, yyvsp[-5].yNumber, yyvsp[-3].yNumber, yyvsp[-1].yNumber)); 
	  ;
    break;}
case 36:
#line 385 "DssParser.y"
{ dssBuilder.addRegion(new FRotBox(FPoint(yyvsp[-9].yNumber, yyvsp[-7].yNumber), yyvsp[-5].yNumber, yyvsp[-3].yNumber, yyvsp[-1].yNumber));
	  ;
    break;}
case 37:
#line 388 "DssParser.y"
{ dssBuilder.addRegion(new FRotRectangle(FPoint(yyvsp[-9].yNumber, yyvsp[-7].yNumber), yyvsp[-5].yNumber, yyvsp[-3].yNumber, yyvsp[-1].yNumber));
	  ;
    break;}
case 38:
#line 391 "DssParser.y"
{ dssBuilder.addRegion(new FRotRhombus(FPoint(yyvsp[-9].yNumber, yyvsp[-7].yNumber), yyvsp[-5].yNumber, yyvsp[-3].yNumber, yyvsp[-1].yNumber));
	  ;
    break;}
case 39:
#line 394 "DssParser.y"
{ dssBuilder.addRegion(new FSector(FPoint(yyvsp[-7].yNumber, yyvsp[-5].yNumber), yyvsp[-3].yNumber, yyvsp[-1].yNumber)); 
	  ;
    break;}
case 40:
#line 397 "DssParser.y"
{ dssBuilder.addRegion(new FPolygon(yyvsp[-1].yPointList[0], yyvsp[-1].yPointList[1], yyvsp[-1].yPointList[0].size()));
            delete [] yyvsp[-1].yPointList; 
	  ;
    break;}
case 41:
#line 402 "DssParser.y"
{ yyvsp[-4].yPointList[0].push_back(yyvsp[-2].yNumber);
                                  yyvsp[-4].yPointList[1].push_back(yyvsp[0].yNumber);
                                  yyval.yPointList = yyvsp[-4].yPointList; ;
    break;}
case 42:
#line 406 "DssParser.y"
{ vector<float> x; x.push_back(yyvsp[-2].yNumber);
                                  vector<float> y; y.push_back(yyvsp[0].yNumber);
                                  vector<float> *v =
                                        new vector<float>[2];
                                  v[0] = x; v[1] = y;
                                  yyval.yPointList = v; ;
    break;}
case 43:
#line 415 "DssParser.y"
{ yyvsp[-2].yRangeList->push_back(*yyvsp[0].yRange);
                                  delete yyvsp[0].yRange;
                                  yyval.yRangeList = yyvsp[-2].yRangeList;
                                ;
    break;}
case 44:
#line 419 "DssParser.y"
{ yyval.yRangeList = new DRangeList;
                                  yyval.yRangeList->push_back(*yyvsp[0].yRange);
                                  delete yyvsp[0].yRange;
                                ;
    break;}
case 45:
#line 424 "DssParser.y"
{ yyval.yNumber = yyvsp[-2].yNumber + yyvsp[0].yNumber; ;
    break;}
case 46:
#line 425 "DssParser.y"
{ yyval.yNumber = yyvsp[-2].yNumber - yyvsp[0].yNumber; ;
    break;}
case 47:
#line 426 "DssParser.y"
{ yyval.yNumber = yyvsp[-2].yNumber * yyvsp[0].yNumber; ;
    break;}
case 48:
#line 427 "DssParser.y"
{ if (yyvsp[0].yNumber == 0.) {
                                      selerrstr<<"Division by 0 in `/' operator."
                                           <<selerror("ArithmeticException");
                                    SELTHROW(DssBuilder::ArithmeticException);
                                  }
                                  yyval.yNumber = yyvsp[-2].yNumber / yyvsp[0].yNumber;
                                ;
    break;}
case 49:
#line 434 "DssParser.y"
{ if (yyvsp[0].yNumber == 0.) {
                                      selerrstr<<"Division by 0 in `modulo' operator."
                                           <<selerror("ArithmeticException");
                                    SELTHROW(DssBuilder::ArithmeticException);
                                  }
                                  yyval.yNumber = fmod(yyvsp[-2].yNumber, yyvsp[0].yNumber);
                                ;
    break;}
case 50:
#line 441 "DssParser.y"
{ double dum;
                                  if (yyvsp[-2].yNumber < 0. && modf(yyvsp[0].yNumber, &dum) != 0.) {
                                      selerrstr<<"Cannot raise "<<yyvsp[-2].yNumber<<" to the power "<<yyvsp[0].yNumber<<" ."
                                           <<selerror("ArithmeticException");
                                    SELTHROW(DssBuilder::ArithmeticException);
                                  }
                                  yyval.yNumber = pow(yyvsp[-2].yNumber, yyvsp[0].yNumber);
                                ;
    break;}
case 51:
#line 449 "DssParser.y"
{ yyval.yNumber = DBL(UNT(yyvsp[-2].yNumber) & UNT(yyvsp[0].yNumber)); ;
    break;}
case 52:
#line 450 "DssParser.y"
{ yyval.yNumber = DBL(UNT(yyvsp[-2].yNumber) | UNT(yyvsp[0].yNumber)); ;
    break;}
case 53:
#line 451 "DssParser.y"
{ yyval.yNumber = DBL(UNT(yyvsp[-2].yNumber) ^ UNT(yyvsp[0].yNumber)); ;
    break;}
case 54:
#line 452 "DssParser.y"
{ yyval.yNumber = DBL(UNT(yyvsp[-2].yNumber) << UNT(yyvsp[0].yNumber)); ;
    break;}
case 55:
#line 453 "DssParser.y"
{ yyval.yNumber = DBL(UNT(yyvsp[-2].yNumber) >> UNT(yyvsp[0].yNumber)); ;
    break;}
case 56:
#line 454 "DssParser.y"
{ yyval.yNumber = DBL(~UNT(yyvsp[0].yNumber)); ;
    break;}
case 57:
#line 455 "DssParser.y"
{ yyval.yNumber = (*yyvsp[-3].yFunc1)(yyvsp[-1].yNumber); ;
    break;}
case 58:
#line 457 "DssParser.y"
{ yyval.yNumber = (*yyvsp[-5].yFunc2)(yyvsp[-3].yNumber, yyvsp[-1].yNumber); ;
    break;}
case 59:
#line 458 "DssParser.y"
{ yyval.yNumber = -yyvsp[0].yNumber; ;
    break;}
case 60:
#line 459 "DssParser.y"
{ yyval.yNumber = yyvsp[-1].yNumber; ;
    break;}
case 62:
#line 462 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, DBL_MAX,
                                                          Unbounded, Unbounded); ;
    break;}
case 63:
#line 464 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, DBL_MAX,
                                                          Unbounded, Unbounded); ;
    break;}
case 64:
#line 466 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, DBL_MAX,
                                                          Unbounded, Unbounded); ;
    break;}
case 65:
#line 468 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, DBL_MAX,
                                                          Unbounded, Unbounded); ;
    break;}
case 66:
#line 470 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, DBL_MAX,
                                                          Unbounded, Unbounded); ;
    break;}
case 67:
#line 472 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[0].yNumber, yyvsp[0].yNumber); ;
    break;}
case 68:
#line 473 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-1].yNumber, yyvsp[-1].yNumber); ;
    break;}
case 69:
#line 474 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-1].yNumber, DBL_MAX,
                                                          Closed, Unbounded); ;
    break;}
case 70:
#line 476 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-2].yNumber, DBL_MAX,
                                                          Closed, Unbounded); ;
    break;}
case 71:
#line 478 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-2].yNumber, DBL_MAX,
                                                          Closed, Unbounded); ;
    break;}
case 72:
#line 480 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-2].yNumber, DBL_MAX,
                                                          Open, Unbounded); ;
    break;}
case 73:
#line 482 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-2].yNumber, DBL_MAX,
                                                          Open, Unbounded); ;
    break;}
case 74:
#line 484 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, yyvsp[0].yNumber,
                                                          Unbounded, Closed); ;
    break;}
case 75:
#line 486 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, yyvsp[-1].yNumber,
                                                          Unbounded, Closed); ;
    break;}
case 76:
#line 488 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, yyvsp[-1].yNumber,
                                                          Unbounded, Open); ;
    break;}
case 77:
#line 490 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, yyvsp[-1].yNumber,
                                                          Unbounded, Closed); ;
    break;}
case 78:
#line 492 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, yyvsp[-1].yNumber,
                                                          Unbounded, Open); ;
    break;}
case 79:
#line 494 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-2].yNumber, yyvsp[0].yNumber); ;
    break;}
case 80:
#line 495 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-3].yNumber, yyvsp[-1].yNumber); ;
    break;}
case 81:
#line 496 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-3].yNumber, yyvsp[-1].yNumber,
                                                          Open, Closed); ;
    break;}
case 82:
#line 498 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-3].yNumber, yyvsp[-1].yNumber,
                                                          Closed, Open); ;
    break;}
case 83:
#line 500 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-3].yNumber, yyvsp[-1].yNumber,
                                                          Open, Open); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/local/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 502 "DssParser.y"


}
